<template>
  <div class="subscription-offers">
    <div
      v-for="pack of sortedSubscriptionsDesktop"
      :key="pack.id"
      class="card-offer is-desktop"
      :class="{ active: pack.id === currentActiveId }"
      @mouseover="currentActiveId = pack.id"
    >
      <div v-if="+pack.id === 1" class="best-choice">
        <StarredText class="best-choice-text">{{
          $t('subscriptionOffers.offers.bestChoice')
        }}</StarredText>
      </div>

      <div class="content">
        <h3
          class="heading--lg text--tertiary pack-title"
          v-html="prettifyName(pack.name)"
        ></h3>

        <p
          class="text--lg text--bold"
          v-html="`${pack.priceHtml}/${$t('common.generic_month')}`"
        ></p>
        <br />

        <span class="badge-free text--sm text--bold text--secondary">{{
          $t('subscriptionOffers.header.card.freeMonth')
        }}</span>

        <AppContentList :list="getPromoLinesForPack(pack)" class="promo-ctn" />
      </div>

      <div class="cta">
        <a
          :href="generateSubscriptionUrl(pack.id)"
          class="button button_full button_blue"
          v-html="$t('subscriptionOffers.offers.btn')"
        ></a>
      </div>
    </div>
    <client-only>
      <div class="is-mobile">
        <slick-slide
          ref="slick"
          :options="slickOptions"
          class="slides-slick custom-slick"
        >
          <div
            v-for="pack of sortedSubscriptionsMobile"
            :key="pack.id"
            class="card-offer card-offer--mobile"
            :class="{ active: pack.id === currentActiveId }"
            @mouseover="currentActiveId = pack.id"
          >
            <div v-if="+pack.id === 1" class="best-choice">
              <StarredText class="best-choice-text">{{
                $t('subscriptionOffers.offers.bestChoice')
              }}</StarredText>
            </div>

            <div class="content">
              <h3
                class="heading--lg text--tertiary pack-title"
                style="font-size: 2.2rem"
                v-html="prettifyName(pack.name)"
              ></h3>
              <p
                class="text--lg text--bold"
                v-html="`${pack.priceHtml}/${$t('common.generic_month')}`"
              ></p>
              <br />
              <span class="badge-free text--sm text--bold text--secondary">{{
                $t('subscriptionOffers.header.card.freeMonth')
              }}</span>

              <AppContentList
                :list="getPromoLinesForPack(pack)"
                class="promo-ctn"
              />
            </div>

            <div class="cta">
              <a
                :href="generateSubscriptionUrl(pack.id)"
                class="button button_full button_blue"
                v-html="$t('subscriptionOffers.offers.btn')"
              ></a>
            </div>
          </div>
        </slick-slide>
      </div>
    </client-only>
  </div>
</template>

<script>
import AppContentList from '~/components/ui/AppContentList'
import StarredText from '~/components/ui/StarredText'

const slickOptions = {
  dots: false,
  infinite: true,
  prevArrow: false,
  nextArrow: false,
  lazyLoad: 'ondemand',
  adaptiveHeight: true,
  autoplay: false,
  autoplaySpeed: 5000,
  edgeFriction: 0.3
}

export default {
  name: 'SubscriptionOffers',
  components: { AppContentList, StarredText },
  props: {
    subscriptions: {
      type: Array,
      required: true
    },
    activeId: {
      type: String,
      required: false,
      default: '0'
    }
  },

  data() {
    return {
      currentActiveId: this.activeId,
      slickOptions: {
        ...slickOptions,
        slidesToShow: 1,
        slidesToScroll: 1
      }
    }
  },

  computed: {
    sortedSubscriptionsDesktop() {
      return this.subscriptions.slice().sort((s1, s2) => {
        return s1.price - s2.price
      })
    },

    sortedSubscriptionsMobile() {
      return this.subscriptions.slice().sort((s1) => {
        return +s1.id === 1 ? -1 : 1
      })
    }
  },

  methods: {
    generateSubscriptionUrl(subscriptionId) {
      const aboRouteForLang = this.$utils.getSubscribeUrlForLang(
        this.$i18n.locale
      )
      return `${this.$config.izneoUrl}/${this.$i18n.locale}/${aboRouteForLang}/${subscriptionId}`
    },

    prettifyName: function (name) {
      return `<span>izneo <strong> ${name.replace(
        'izneo ',
        ''
      )}</strong></span>`
    },

    getPromoLinesForPack(pack) {
      const lines = [
        this.$t(
          `subscriptionOffers.offers.${
            +pack.id === 28 ? 'entireCatalogWebtoon' : 'entireCatalog'
          }`
        ),

        this.$tc('subscriptionOffers.offers.multiAccount', pack.multiAccount, {
          count: pack.multiAccount
        }),

        this.$t('subscriptionOffers.offers.devices'),
        this.$t('subscriptionOffers.offers.parentalControl')
      ]

      return lines
    }
  }
}
</script>

<style lang="scss" scoped>
.subscription-offers {
  display: flex;
  justify-content: center;

  .is-mobile {
    display: none;
  }

  .is-desktop {
    display: block;
  }
  @media (max-width: 768px) {
    .is-mobile {
      display: block;
      width: 100%;
    }

    .is-desktop {
      display: none;
    }
  }

  .card-offer {
    width: 385px;
    border-radius: 4px;
    box-shadow: 0 5px 10px 0 rgba(0, 0, 0, 0.15);
    margin: 0 30px;
    padding: 35px;
    text-align: center;
    position: relative;
    overflow: hidden;

    &--mobile {
      width: unset;
      max-width: 350px;
      margin: 10px 0;
      padding: 0 17px;
    }

    .best-choice {
      background: $color-secondary;
      position: absolute;
      top: 0;
      left: 0;
      right: 0;
      height: 50px;

      display: flex;
      flex-direction: column;
      justify-content: center;

      .best-choice-text {
        text-align: center;
        font-size: 14px;
        font-weight: bold;
        color: white;
      }
    }

    .content {
      margin: 50px 0 120px;

      .pack-title {
        line-height: 1;
        margin-bottom: 10px;
        display: flex;
        justify-content: center;
        align-items: center;
        min-height: 70px;
      }
    }

    .cta {
      position: absolute;
      bottom: 35px;
      left: 35px;
      right: 35px;
    }

    &--mobile .cta {
      bottom: 18px;
      left: 5px;
      right: 5px;
    }

    .promo-ctn {
      margin: 30px 0;
    }

    &--mobile .promo-ctn {
      min-height: 250px;
    }

    .badge-free {
      background-color: rgba(255, 100, 30, 0.12);
      padding: 5px;
      margin-bottom: 20px;
    }

    .button {
      width: 100%;
    }

    &--mobile .button {
      padding: 24px 10px;
    }
  }

  ::v-deep {
    .slick-list {
      padding: 0 10% 0 0;
    }

    .slick-slide {
      margin: 0 10px;

      > div {
        text-align: left;
      }
    }
    .slick-track {
      align-items: start;
    }
  }
}
</style>
